
#include "stdafx.h"
#include "GzTool.h"
#include "zlib/zlib.h"

struct GzHeader
{
	BYTE Magic[2];	// 0x1f, 0x8b
	BYTE Method;	// deflate:0x08 , ͗\
	BYTE Flag;		// bit0:Text
					// bit1:No2 or 3 or... of MultiPartGzip
					// bit2:ʂȗ̈悪
					// bit3:t@C
					// bit4:Rg
					// bit5:t@C͈ÍĂ
	DWORD Update;	// ŏIXVBUnix`B
	BYTE ExFlag;	// gtO
	BYTE OSType;	// t@C쐬OS̎(ڍח)

//	7:bit1ZbgĂƂAp[gԍ(0,1,2,...)	2byte͂Ȃ
//	8:bit2ZbgĂƂAʂȗ̈̒		2byte͂Ȃ
//	9:ʂȗ̈									?byte͂Ȃ
//	10:bit3ZbgĂƂÃt@C	?byte͂Ȃ('\0'ŏI)
//	11:bit4ZbgĂƂARg			?byte͂Ȃ('\0'ŏI)
//	12:bit5ZbgĂƂAÍwb_		12byte͂Ȃ
};
//	13:kf[^						?byte
//	14:32rbgCRC						4byte
//	15:t@CTCY&0xffffffff		4byte


bool CGzTool::Check( const char* fname, unsigned long fsize )
{
	const unsigned char* hdr = CTool::common_buf;
	unsigned long siz = (fsize>XACR_BUFSIZE ? XACR_BUFSIZE : fsize);
//--------------------------------------------------------------------//

	return ( siz>=10 && hdr[0]==0x1f
		&& ( hdr[1]==0x8b || hdr[1]==0x9e ) );
}

bool CGzTool::Extract( const char* fname,const char* ddir )
{
	unsigned char* buf = CTool::common_buf;
//--------------------------------------------------------------------//

	// t@CΓǂݍ
	char outname[MAX_PATH];

	FILE* fp = fopen( fname,"rb" );
	if( !fp )
		return false;

	GzHeader head;
	if( 10 != fread( &head,1,10,fp ) )
	{
		fclose(fp);
		return false;
	}
	if( head.Flag&(1<<3) )
	{
		if( head.Flag&(1<<1) )fgetc(fp),fgetc(fp);
		if( head.Flag&(1<<2) )
		{WORD splen=0;fread(&splen,2,1,fp);fread(buf,1,splen,fp);}
		for( int i=0; i!=65536; i++ )
		{
			int c=fgetc(fp);
			if( c==-1 || c==0 ){buf[i]=0;break;}
			buf[i]=c;
		}
		strncpy( outname,(char*)buf,MAX_PATH );
	}
	else
	{
		kiutil::getOriginalName( outname,fname,
			0==stricmp(kiutil::pathExt(fname),"gz") ? NULL : "ungzip" );
	}
	fclose( fp );

	gzFile gfp=gzopen( fname,"rb" );
	if( !gfp )return false;

	FILE* fwp=fopen( outname,"wb" );
	if( fwp )
	{
		size_t s;
		while( s=gzread(gfp,buf,XACR_BUFSIZE) )
		{
			if( s==-1 )
				break;
			fwrite( buf,1,s,fwp );
		}
		fclose(fwp);
	}
	gzclose( gfp );
	return true;
}
